// last updated May 3, 2007

#include <18F452.h>
#include <math.h>
//#device adc=8
#use delay(clock=16000000)
#fuses H4, BORV20, PUT, NOLVP, NOWDT
#use rs232(baud=9600,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=8)
#define STATUS_LED PIN_A4

#define _RED     224
#define _GREEN   28
#define _BLUE    3
#define _YELLOW  _GREEN+_RED
#define _CYAN    _GREEN+_BLUE
#define _MAGENTA _RED+_BLUE
#define _ORANGE  234
#define _WHITE   255
#define _BLACK   0

#DEFINE   _LCDPWR PIN_D1 //LCD defines
#DEFINE CS PIN_C4
#DEFINE LCDCLOCK PIN_C3
#DEFINE LCDDATA PIN_B5
#DEFINE _RESET PIN_B4
#DEFINE BLCONTROL PIN_D0

// Epson S1D15G10 Command Set
#define DISON       0xaf
#define DISOFF      0xae
#define DISNOR      0xa6
#define DISINV      0xa7
#define COMSCN      0xbb
#define DISCTL      0xca
#define SLPIN       0x95
#define SLPOUT      0x94
#define PASET       0x75
#define CASET       0x15
#define DATCTL      0xbc
#define RGBSET8     0xce
#define RAMWR       0x5c
#define RAMRD       0x5d
#define PTLIN       0xa8
#define PTLOUT      0xa9
#define RMWIN       0xe0
#define RMWOUT      0xee
#define ASCSET      0xaa
#define SCSTART     0xab
#define OSCON       0xd1
#define OSCOFF      0xd2
#define PWRCTR      0x20
#define VOLCTR      0x81
#define VOLUP       0xd6
#define VOLDOWN     0xd7
#define TMPGRD      0x82
#define EPCTIN      0xcd
#define EPCOUT      0xcc
#define EPMWR       0xfc
#define EPMRD       0xfd
#define EPSRRD1     0x7c
#define EPSRRD2     0x7d
#define NOP         0x25

// FOR BOOTLOADER (COLT)
#build(reset=0x200)
#build(interrupt=0x208)
#org 0x0000,0x01ff
void bootloader() {
#asm
   nop
#endasm
}  //reserve space for the bootloader

void glcd_xy(int8 x, int8 y);
void glcd_putc(int8);
void glcd_clear(void);

//
void write_lcd(int1, unsigned int);
void init_lcd(int1);//0== 8 bit color, 1== send 16 bits (4096 color pallete)
void LCD_pixel_write8(unsigned int8, unsigned int8, unsigned int8);//8 bit color
void LCD_pixel_write16(unsigned int8, unsigned int8, unsigned int16);//takes a 16 bit color (RGB565) and shifts down to 12
void fill8(void);
void fill12(void);
//void backlight_on(void);
//void backlight_off(void);

// GLOBAL VARIABLES
int8 glcd_cursor_x=1, glcd_cursor_y=1, glcd_color=120;


//----------------------------------------------------

void main()
{
#include "penguin.c"
   unsigned int16 counter=0;
   unsigned int x,y;
   int8 eepromdata=123;
   int16 z;
   long int eepromaddress=0;
    unsigned int n, h, v;
    float fx,fy;


   setup_wdt(WDT_OFF);
 //  setup_adc_ports(NO_ANALOGS|VSS_VDD);
 //  setup_adc(ADC_OFF|ADC_TAD_MUL_0);
   setup_psp(PSP_DISABLED);
   setup_spi(FALSE);
   setup_wdt(WDT_OFF);
   setup_timer_0(RTCC_INTERNAL);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
  // setup_comparator(NC_NC_NC_NC);
  // setup_vref(FALSE);
   setup_low_volt_detect(FALSE);
//=========================================

for(n=1; n<=2; n++){
  output_low(STATUS_LED);
  delay_ms(150);
  output_high(STATUS_LED);
  delay_ms(150);
}

init_lcd(0);
glcd_color = _WHITE;
fill8();

// put a blue line along the bottom
for(n=10;n<120;n++){
   LCD_pixel_write8(n,130,_BLUE);
}

delay_ms(4000);

// show an image
glcd_cursor_x=1; glcd_cursor_y=1;
for(v=0; v<66; v++){
   for(h=0; h<60; h++){
      z = (int16)(v)  *  60  +  (int16)(h);
      LCD_pixel_write8(h, v, penguin[z]);
   }
}

delay_ms(5000);

//  show some text
glcd_cursor_x=1; glcd_cursor_y=100; glcd_color=_RED;
printf(glcd_putc, "ABCDEFGHIJKLMOPQRSTUVWXYZ");

delay_ms(2000);

//  make some sine waves
for(fx=0;fx<=129;fx=fx+1){
   fy=((sin(fx/10    )*20)+ 64)  ; LCD_pixel_write8((int8)(fx), (int8)(fy),_BLUE);
   fy=((sin(fx/10+128)*20)+ 64); LCD_pixel_write8((int8)(fx), (int8)(fy),_GREEN);
   fy=((cos(fx/10    )*20)+ 64); LCD_pixel_write8((int8)(fx), (int8)(fy),_RED);
   fy=((cos(fx/10+128)*20)+128)/2; LCD_pixel_write8((int8)(fx), (int8)(fy),_YELLOW);
}

//  a simple terminal
glcd_cursor_x=1; glcd_cursor_y=1; glcd_color=_BLUE;
while(1){
   glcd_putc(getc());
}


} // end of main

//======================================

void LCD_pixel_write8(unsigned int8 x, unsigned int8 y, unsigned int8 color)//8 bit color // x and y range 1-130 color 0-255 (RRRGGGBB)
   {

   int8 t;

   if ((x > 130) | (x < 1) | (y > 130) | (y < 1))
      return;

// for some reason, x and y are reversed. this fixes it
   t=x;
   x=y;
   y=t;


   x=x+1;
   y=y-1;

   write_lcd(0, 0x75);//page start/end ram
   write_lcd(1, x);
   write_lcd(1, 131);
   write_lcd(0, 0x15);//column start/end ram
   write_lcd(1, y);
   write_lcd(1, 129);
   write_lcd(0, RAMWR);//RAM WRITE
   write_lcd(1, color);
   }

//----------------------------------------------

void LCD_pixel_write16(unsigned int8 x, unsigned int8 y, unsigned int16 color)// x and y range 1-128 color 16 bit (RRRRRGGGGGGBBBBB)
   {
   unsigned int8 colorhigh,colorlow,red,green,blue,data1,data2,data3;
   if ((x > 130) | (x < 1) | (y > 130) | (y < 1))
      return;
   x=x+1;
   y=y-1;
   colorhigh=make8(color,1);//high byte
   colorlow=make8(color,0);//low byte
   red = (colorhigh >> 3);
   green = ((colorhigh & 0b00000111) << 3) + ((colorlow & 0b11100000) >> 5);
   blue = (colorlow & 0b00011111);
   red=red>>1;//red was 5 bits, all now need to be 4
   green=green>>2;//green was 6 bits
   blue=blue>>1;
   data1=((red<<4)+green);//send data:RRRRGGGG
   data2=((blue<<4)+red);//BBBBRRRR
   data3=((green<<4)+blue);//GGGGBBBB
   write_lcd(0, 0x75);//page start/end ram
   write_lcd(1, x);
   write_lcd(1, 131);
   write_lcd(0, 0x15);//column start/end ram
   write_lcd(1, y);
   write_lcd(1, 129);
   write_lcd(0, RAMWR);//ram write
   write_lcd(1, data1);
   write_lcd(1, data2);
   write_lcd(1, data3);
   }

//---------------------------------------------

void fill12(void)
   {
   unsigned int16 i;
   unsigned int8 x;
   write_lcd(0, PASET);//page start/end ram
   write_LCD(1, 2);//for some reason it starts at 2
   write_LCD(1, 131);
   write_lcd(0, CASET);//column start/end ram
   write_LCD(1, 0);
   write_LCD(1, 129);

   write_lcd(0, RAMWR);//write a background
   for (i=0; i< 16900; i++)
      {
      write_LCD(1, 0x0000);//black
      write_LCD(1, 0x0000);
      write_LCD(1, 0x0000);
      }
   for (x=1;x<=130;x++)//draw a border
      {
      lcd_pixel_write16(x,1,0xFBFF);
      lcd_pixel_write16(x,130,0xFBFF);
      lcd_pixel_write16(1,x,0xFBFF);
      lcd_pixel_write16(130,x,0xFBFF);
      }
   }

//---------------------------------------------------

void glcd_clear(void){

   int16 i;

   write_lcd(0, RAMWR);
   for (i=0; i< 16900; i++)
         write_LCD(1, 0x00);      //black

}

//--------------------------

void fill8(void)
   {
   unsigned int16 i;
   unsigned int8 x;
   write_lcd(0, PASET);//page start/end ram
   write_LCD(1, 2);//for some reason it starts at 2
   write_LCD(1, 131);
   write_lcd(0, CASET);//column start/end ram
   write_LCD(1, 0);
   write_LCD(1, 129);

   write_lcd(0, RAMWR);//write a background
   for (i=0; i< 16900; i++)
         write_LCD(1, glcd_color);

/*
   for (x=1;x<=130;x++)//draw a border
      {
      lcd_pixel_write8(x,1,0xfF);    // left side
      lcd_pixel_write8(x,130,0xfF);  // right side
      lcd_pixel_write8(1,x,0xff);    // top
      lcd_pixel_write8(130,x,0xff);  // bottom
      }
*/
   }

//------------------------------------------


void write_lcd(int1 LCDmode, unsigned int data)//mode ==0 send a command, mode==1 sends data
   {

int8 n,b;

   if (!LCDmode)
      output_low(LCDDATA);//when entering commands: SI=LOW at rising edge of 1st SCL
   else
      output_high(LCDDATA);//send data
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);

   //send data, 8th bit first

   b=7;
//   #use fast_io(B)
  // #use fast_io(C)
   for(n=0;n<8;n++){
      if(bit_test(data, b)==1) output_high(LCDDATA);
      else  output_low(LCDDATA);
      output_low(LCDCLOCK);
      b--;
      output_high(LCDCLOCK);
   }
//   #use standard_io(B)
  // #use standard_io(C)

/*
   if (data & 128)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //7th bit
   if (data & 64)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //6th bit
   if (data & 32)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //5th bit
   if (data & 16)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //4th bit
   if (data & 8)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //3rd bit
   if (data & 4)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //2nd bit
   if (data & 2)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   //1st bit
      if (data & 1)
      output_high(LCDDATA);
   else
      output_low(LCDDATA);
   output_low(LCDCLOCK);
   output_high(LCDCLOCK);
   output_high(CS);
   output_low(CS);
*/
   }

//---------------------------------------

void init_lcd(int1 colormode)//colormode==0 8 bit
   {//mode ==0 send a command, mode==1 sends data
   unsigned int16 i;
   unsigned int8 x,y;
//   output_low(_LCDPWR);//apply power to LCD
//   delay_ms(250);
   output_low(CS);
   output_low(LCDDATA);
   output_high(LCDCLOCK);
   output_high(_reset);
   output_low(_reset);
   output_high(_reset);
   output_high(LCDCLOCK);
   output_high(LCDDATA);
   delay_ms(1);


   write_lcd(0, DISCTL);//display control
   write_LCD(1, 0x03);///original values
   write_LCD(1, 0x20);
   write_LCD(1, 0x0C);
   write_LCD(1, 0x00);

/*
// try this instead of the above
   write_lcd(0, DISCTL);//display control
   write_LCD(1, 0x0C);
   write_LCD(1, 0x20);
   write_LCD(1, 0x0C);
   write_LCD(1, 0x00);
*/

   write_lcd(0, NOP);//no op

   write_lcd(0, COMSCN);//common scan direction (goes wierd without this)
   write_LCD(1, 0x01);

   write_lcd(0, OSCON);//oscillator on
   write_lcd(0, SLPOUT);//sleep out
   write_lcd(0, VOLCTR);//electronic volume control
   write_LCD(1, 0x05);//cares about lower 6 bits   V1 volume
   write_LCD(1, 0x01);//cares about lower 3 bits   1+Rb/Ra, supposed to specify "resistance ratio of internal resistor"

   write_lcd(0, PWRCTR);//power control
   write_LCD(1, 0x0f);//turn stuff on
   write_LCD(1, 0x64);

   write_lcd(0, DISINV);//inverse display

   write_lcd(0, DATCTL);//Data control
   write_LCD(1, 0x00);
   write_LCD(1, 0x00);

//   write_lcd(0, TMPGRD);//temp gradient
//   write_LCD(1, 0);//

   if (colormode == 0)//8 bit color
      write_LCD(1, 0x01);
   else
      write_LCD(1, 0x02);//4096 colors
   write_LCD(1, 0x00);

   write_lcd(0, NOP);//no op
   if (colormode == 0)//8 bit color
      {
      write_lcd(0, RGBSET8);//setup color lookup table
      //red
      write_LCD(1, 0);
      write_LCD(1, 2);
      write_LCD(1, 4);
      write_LCD(1, 6);
      write_LCD(1, 8);
      write_LCD(1, 10);
      write_LCD(1, 12);
      write_LCD(1, 15);
      //green
      write_LCD(1, 0);
      write_LCD(1, 2);
      write_LCD(1, 4);
      write_LCD(1, 6);
      write_LCD(1, 8);
      write_LCD(1, 10);
      write_LCD(1, 12);
      write_LCD(1, 15);
      //blue
      write_LCD(1, 0);
      write_LCD(1, 4);
      write_LCD(1, 9);
      write_LCD(1, 15);
      }


   write_lcd(0, DISON);//display on
   delay_ms(300);
   write_lcd(0, NOP);//no op

// orig is 150
// 200 is too white
// 160 is too light
// 150 is too light
// 140 is best
// 130 colors are too dark
// 100 not visable
// 50 not visable
   for (i=0; i<175; i++)
      {
      write_lcd(0, VOLUP);//changes contrast, find correct setting by trial and error
      }
   }



//-----------------------------------------

void glcd_xy(int8 x, int8 y){}

//-----------------------------------------

//  Uses the following global variables
//  glcd_cursor_x, glcd_cursor_y, glcd_color
//
void glcd_putc(int8 character){

   #define FONT_WIDTH 7
   #define FONT_HIGHT 12

#include <font1.c>

   int1 pixel;
   int8 h,v,t,ch;
   int16 top_row;

   if(character==13){
      glcd_cursor_x = 1; // (CR)
      glcd_cursor_y += FONT_HIGHT; // (LF)
      return;
   }
   if(character==8){  // (backspace)
      glcd_cursor_x -= 8;
      for(v=0; v<12; v++){
         for(h=0; h<8; h++){
            LCD_pixel_write8(glcd_cursor_x+h, glcd_cursor_y+v, _WHITE);
         }
      }
      return;
   }

   if(character==03){  // control c
      glcd_cursor_x = 1;
      glcd_cursor_y = 1;
      t=glcd_color;
      glcd_color = _WHITE;
      fill8();
      glcd_color = t;
      return;
   }

   if(character==27){  // (ESC)
       ch = getc();
       if      (ch=='r')glcd_color = _RED;
       else if (ch=='g')glcd_color = _GREEN;
       else if (ch=='b')glcd_color = _BLUE;
       else if (ch=='y')glcd_color = _YELLOW;
       else if (ch=='c')glcd_color = _CYAN;
       else if (ch=='m')glcd_color = _MAGENTA;
       else if (ch=='w')glcd_color = _WHITE;
       else if (ch=='k')glcd_color = _BLACK;
       else if (ch=='f'){
         glcd_cursor_x = 1;
         glcd_cursor_y = 1;
         fill8();
       }
       return;
   }

     if(character=='<'){
        write_lcd(0, VOLDOWN);
        printf("-");
        return;
     }
     if(character=='>'){
        write_lcd(0, VOLUP);
        printf("+");
        return;
     }

   if(glcd_cursor_x + FONT_WIDTH > 130){
      glcd_cursor_x = 1; // (CR)
      glcd_cursor_y += FONT_HIGHT; // (LF)
   }
   //if(glcd_cursor_y + FONT_HIGHT > 130){
      // scroll
   //}


   // locate the character matrix
   top_row = ((int16)character - 32) * 12;

   for(v=0; v<12; v++){

      // do a row
      for(h=0; h<8; h++){
         pixel = bit_test(font1[top_row+v], 7-h);
         if(pixel){
            LCD_pixel_write8(glcd_cursor_x+h, glcd_cursor_y+v, glcd_color);
         }
      }
   }
   glcd_cursor_x += 8;

} // function







